<?php

  class mw_data_sql_install extends mw_data{

    public function install_sql($params){
      $env = $this->env();
      $data = $env->data();
      $sgbd = $data->sgbd();
      $host = isset($params["host"]) ? $params["host"] : "";
      $base = isset($params["base"]) ? $params["base"] : "";
      $user = isset($params["user"]) ? $params["user"] : "";
      $password = isset($params["password"]) ? $params["password"] : "";
      try{
        $sgbd->connect(
          $host,
          $base,
          $user,
          $password
        );
        $sgbd->select_db($base);
      }
      catch(Exception $e){
        return $e->getMessage();
      }
      if(!($version = $env->version("mtweb"))){
        return "impossible de lire la version de mtweb";
      }
      try{
        $EXISTS =
            $sgbd->table_exists("#--actions_roles")
        ||  $sgbd->table_exists("#--config")
        ||  $sgbd->table_exists("#--roles")
        ||  $sgbd->table_exists("#--users")
        ||  $sgbd->table_exists("#--users_roles")
        ||  $sgbd->table_exists("#--versions");
      }
      catch(Exception $e){
        return "impossible de savoir si les tables existent deja";
      }
      if($EXISTS){
        return "des tables a installer existent deja en base. installation annulee";
      }
      try{

        $sql =
         "SET SQL_MODE=\"NO_AUTO_VALUE_ON_ZERO\"";
        $sgbd->query($sql);

        $sql =
          "CREATE TABLE #--actions_roles("
        ." id int(11) NOT NULL AUTO_INCREMENT,"
        ." `action` varchar(255) NOT NULL,"
        ." id_role int(11) NOT NULL,"
        ." PRIMARY KEY (id),"
        ." KEY id_role(id_role)"
        .") DEFAULT CHARSET=utf8";
        $sgbd->query($sql);

        $sql =
         "CREATE TABLE #--config("
        ."  id int(11) NOT NULL AUTO_INCREMENT,"
        ."  `key` varchar(255) NOT NULL,"
        ."  `value` text NOT NULL,"
        ."  PRIMARY KEY (id)"
        .") DEFAULT CHARSET=utf8";
        $sgbd->query($sql);

        $sql =
         "CREATE TABLE #--roles("
        ."  id int(11) NOT NULL AUTO_INCREMENT,"
        ."  nom varchar(255) NOT NULL,"
        ."  intitule varchar(255) NOT NULL,"
        ."  KEY id (id)"
        .") DEFAULT CHARSET=utf8";
        $sgbd->query($sql);

        $sql =
         "CREATE TABLE #--users("
        ."  id int(11) NOT NULL AUTO_INCREMENT,"
        ."  login varchar(255) NOT NULL,"
        ."  password varchar(255) NOT NULL,"
        ."  email varchar(255) NOT NULL,"
        ."  PRIMARY KEY (id)"
        .") DEFAULT CHARSET=utf8";
        $sgbd->query($sql);

        $sql =
         "CREATE TABLE #--users_roles("
        ."  id_user int(11) NOT NULL,"
        ."  id_role int(11) NOT NULL,"
        ."  PRIMARY KEY (id_user,id_role),"
        ."  KEY id_role(id_role)"
        .") DEFAULT CHARSET=utf8";
        $sgbd->query($sql);

        $sql =
         "CREATE TABLE #--versions("
        ."  id INT(11) NOT NULL AUTO_INCREMENT,"
        ."  application VARCHAR(255) NOT NULL,"
        ."  version VARCHAR(255) NOT NULL,"
        ."  PRIMARY KEY (id)"
        .") DEFAULT CHARSET=utf8";
        $sgbd->query($sql);

      }
      catch(Exception $e){
        return "imposible de creer les tables en base";
      }
      try{
        $sql =
         "INSERT INTO #--actions_roles(`id`, `action`, `id_role`) VALUES"
        ."(13, 'admin', 1),"
        ."(14, 'users', 2),"
        ."(19, 'users/identification', 0),"
        ."(20, 'config', 3)";
        $sgbd->query($sql);

        $sql =
         "INSERT INTO #--config(id, `key`, `value`) VALUES"
        ."(1, 'site_name', 'mtweb'),"
        ."(2, 'max_list', '10'),"
        ."(3, 'description', ''),"
        ."(4, 'out', 'default'),"
        ."(5, 'start_action', ''),"
        ."(6, 'contact_form', '0'),"
        ."(8, 'email', ''),"
        ."(9, 'captcha', '0'),"
        ."(16, 'start_action_params', ''),"
        ."(20, 'out_navig_menu_top', 'on'),"
        ."(22, 'out_colonne', 'on'),"
        ."(29, 'default_allow', '1')";
        $sgbd->query($sql);

        $sql =
         "INSERT INTO #--roles(`id`, `nom`, `intitule`) VALUES"
        ."(0, 'guest', 'invité'),"
        ."(1, 'admin', 'administrateur'),"
        ."(2, 'membre', 'membre'),"
        ."(3, 'webmaster', 'webmaster')";
        $sgbd->query($sql);

        $sql =
         "INSERT INTO #--versions(`application`, `version`) VALUES"
        ."('mtweb', ".$this->eq($version).")";
        $sgbd->query($sql);

      }
      catch(Exception $e){
        return "les tables ont ete ajoutees en base mais impossible d'y enregistrer les valeurs par defaut.";
      }
      return true;
    }

  }
